Attribute VB_Name = "Module1"
Option Explicit

'************************************    ŧi   ****************************************
'oU Coil˸m}
Public Function GetCoilDevAddr(ByVal Coil_name As String) As String
   Dim DevAddr$
   
   Select Case Coil_name
     Case "X0"
       DevAddr$ = "0400"
     Case "Y0"
       DevAddr$ = "0500"
     Case "M0"
       DevAddr$ = "0800"
     Case "S0"
       DevAddr$ = "0000"
     Case "M1"
       DevAddr$ = "0801"
     Case "S2"
       DevAddr$ = "0002"
   End Select
   
   GetCoilDevAddr = DevAddr$
End Function

'p CheckSum   LRC 覡 (ASCII Mode)
Public Function Check_LRC(ByVal Check_data As String)
' Calculate LRC and return

Dim Dummy$(), Dummy_data, Index, i As Integer
Dim result_lrc$
Index = 1
Dummy_data = 0

Erase Dummy$
ReDim Dummy$(1 To Int(Len(Check_data) / 2 - 0.5) + 1)

Do
    Dummy$(Index) = Left(Check_data$, 2)
    Check_data$ = Mid(Check_data$, 3)
    Index = Index + 1
Loop Until Len(Check_data$) = 0

For i = 1 To Index - 1
    Dummy_data = Dummy_data + Val("&H" + Dummy$(i))
Next i

result_lrc$ = Hex(256 - (Dummy_data Mod 256))
result_lrc$ = IIf(Len(result_lrc$) = 1, "0" & result_lrc$, result_lrc$)
Check_LRC = IIf(Len(result_lrc$) > 2, Right(result_lrc$, 2), result_lrc$)

End Function

'NƦǰe PLC
Public Function Send_To_PLC(ByVal objMSCOMM As MSComm, ByVal send_string$) As String
  
 'STEP1:NզXr... p CheckSum
  send_string$ = send_string$ + Check_LRC(send_string$)
 
 'STEP2: ":"  "LRC
  send_string$ = Chr(&H3A) + send_string$ + Chr(&HD) + Chr(&HA)
  
 'O_ݭnl
  If objMSCOMM.PortOpen = False Then objMSCOMM.PortOpen = True
  
  objMSCOMM.Output = send_string$
  
   Send_To_PLC = send_string$
End Function

Public Function Receive_to_PLC(ByVal objMSCOMM As MSComm, Optional Delay_time = 20000) As String
   Dim Request_times  As Long, Buffer$

  '^ǭ
   Do Until Request_times > Delay_time
         
      If objMSCOMM.InBufferCount <> 0 Then Buffer$ = Buffer$ + objMSCOMM.Input
   
      Request_times = Request_times + 1
          
      DoEvents
         
      If Left(Buffer$, 1) = Chr(&H3A) And InStr(Buffer$, vbCrLf) Then
          Exit Do
      End If
   Loop

   Receive_to_PLC = Buffer$
   
End Function
